;;   Buffer routines for Jed.  Functions included here are:
;;    
;;     list_buffers  : pop up a list of buffers
;;     save_buffers  : saves buffers that are associated with a file
;;                     with no user intervention
;;     recover_file  : restore buffer from autosave file.
;;
;;
(
  [i tmp this name flags] "*BufferList*" =tmp
  whatbuf =this
  tmp pop2buf
  erase_buffer
  "U:Undo O:Overwrite R:Readonly D:Disk File Changed, A:Autosave, M:Modified\n\n"
  insert
  "UORDAM\tBuffer Name" insert 30 goto_column "Dir/File\n" insert
  buffer_list { =name
    name int 32 == {continue} if   ;; internal buffers begin with a space
    
    name setbuf getbuf_info =flags tmp setbuf
    bol
    32 =i
    { i }{ flags i & {"1"}{"0"} else insert i 1 shr =i } while
    "\t" insert
    insert ;; buffer name
    30 goto_column
    eolp {eol " " insert} !if
    insert insert               ;; dir/file
    newline
  } loop
  bob
  0 set_buffer_modified_flag
  this pop2buf
) list_buffers

;;
;;  save some buffers--- saves only modified buffers associated with
;;   files.  Does not ask user.
;;

(
   [file dir flags buf]
   
   buffer_list { =buf
      buf int 32 == {continue} if         ;; internal buffer
      buf int "*" int == {continue} if    ;; special buffer
      
      buf setbuf
      getbuf_info  =flags pop =dir =file
      
      file strlen {continue} !if          ;; no file assciated with it
      flags 1 & {
	dir file strcat write_buffer {"Error writing buffer" error} !if
      } if
   } loop   
) save_buffers
      
     
;; write region to file
(
   [file]
   markp {"Set Mark first!" error} !if
   "File:" read_file_from_mini =file
   file write_region_to_file
) write_region

(
   [file]
   markp {"Set Mark first!" error} !if
   "File:" read_file_from_mini =file
   file append_region_to_file
) append_region

;%% restores buffer from autosave file.
(
  [flags file dir as buf]
  getbuf_info =flags pop =dir =file
  file strlen {"Buffer not associated with a file." error} !if
  dir file make_autosave_filename =as
  as file_status 1 !=
    {
      as " not readable." strcat error
    } if
    
  whatbuf =buf
  as dir file strcat file_time_compare
  {
     as " more recent. Use it"
  }{
     as " not recent. Use it"
  } else
  strcat get_yes_no 0 >
   {
      buf setbuf
      erase_buffer
      as insert_file pop bob
   } if
) recover_file

  
