;; EDT emulation for JED  -- Application Keypad.
;;
;;  To load this, put the line:  "edt.sl" evalfile
;;   in your jed.rc (.jedrc) file
;;
;; Here the user gets to choose the action of the 'subs' key (Gold-enter)
;; By default, it behaves as EDT.  By putting the next line in JED.RC, this
;; key is bound to a more conventional query replace
;;"replace"	"^[OP^[OM"	setkey  ;; subs (query replace)
;;
;; The default binding for the quote keys (", ') is 'text_smart_quote'.
;; Most users do not seem to like this so it is unset here.
"self_insert_cmd"	"\""	setkey
"self_insert_cmd"	"'"	setkey
;;
;; In addition, if you want the ^H key to move to the beginning of line
;; then uncomment the next two lines.
;;    "^H" unsetkey
;;    "bol"		"^H"		setkey  ;; beginning of line
;; By default, these are bound
;; to help functions (man page, etc...).

;; conventional subs key definition:
"edt_subs"	"^[OP^[OM"	setkey  ;; subs (edt style)

#IBMPC
  1 =NUMLOCK_IS_GOLD  ;; This sets the numlock key on the 'application keypad'
#end

;;
;; Escape sequences for EDT keypad:
;;
;; FP1 = ^[OP       FP2 = ^[OQ      FP3 = ^[OR       PF4 = ^[OS
;;   7 = ^[Ow         8 = ^[Ox        9 = ^[Oy         - = ^[Om
;;   4 = ^[Ot         5 = ^[Ou        6 = ^[Ov         , = ^[Ol
;;   1 = ^[Oq         2 = ^[Or        3 = ^[Os
;;            0 = ^[Op            . = ^[On         enter = ^[OM

1 =WANT_EOB

"Edt_Loaded" defined?
{ [Edt_Loaded]
  [edt_pbuf] ;; a real buffer
  " <edt>" =edt_pbuf
  whatbuf edt_pbuf setbuf
  sw2buf
} !if

;; unset some of default jed keys--- lose window capability on "^W" one
;; "^W" unsetkey
;; redraw "^W" setkey

;;"^K" unsetkey ;;-- unset this, we lose kill line in emacs.sl
"^U" unsetkey   ;; emacs.sl rebinds this to digit-arg

;; Give user ability to exit via GOLD-Q, GOLD-E
"exit_jed" "^[OPQ" setkey
"exit_jed" "^[OPE" setkey
( exit_jed ) quit
( exit_jed ) exit

;;
;;  Gold-Gold to toggle keypad state
;;
#IBMPC
  "^@;" unsetkey  "edt_togglekp"  "^@;"  setkey  ;; IBM F1 key
#endif
[Edt_Keypad] 1 =Edt_Keypad
(
  Edt_Keypad {
    "_IBMPC" defined? {"Gold OFF"}{"Numeric." "\e>" tt_send} else message
  }{
    "_IBMPC" defined? {"Gold ON"}{"Application." "\e=" tt_send} else message
  } else
#IBMPC
   NUMLOCK_IS_GOLD not =NUMLOCK_IS_GOLD
#endif
  Edt_Keypad not =Edt_Keypad
) edt_togglekp

"edt_togglekp"	"^[OP^[OP"	setkey  ;; Gold-Gold toggles keypad
"self_insert_cmd" "^I"		setkey  ;; tab inserts tab.
"edt_delbol"	"^U"		setkey  ;; delete to bol
"edt_help"	"^[OQ"		setkey  ;; help
"edt_findnxt"	"^[OR"		setkey  ;; findnxt
"edt_ldel"	"^[OS"		setkey  ;; del l
"edt_cdel"	"^[Ol"		setkey  ;; del c
"edt_wdel"	"^[Om"		setkey  ;; del w
"set_mark_cmd"	"^[On"		setkey  ;; select
"edt_line"	"^[Op"		setkey  ;; line
"edt_word"	"^[Oq"		setkey  ;; word
"edt_eol"	"^[Or"		setkey  ;; eol
"edt_char"	"^[Os"		setkey  ;; char
"edt_advance"	"^[Ot" 		setkey  ;; advance
"edt_backup"	"^[Ou" 		setkey  ;; backup
"edt_cut"	"^[Ov"	        setkey  ;; cut
"edt_page"	"^[Ow"		setkey  ;; page
"edt_sect"	"^[Ox"		setkey  ;; sect
"edt_append"	"^[Oy"		setkey  ;; append
"edt_help"	"^[OP^[OQ"	setkey  ;; help
"edt_find"	"^[OP^[OR" 	setkey  ;; find
"edt_uldel"	"^[OP^[OS"	setkey  ;; udel l
"edt_ucdel"	"^[OP^[Ol"	setkey  ;; udel c
"edt_uwdel"	"^[OP^[Om"	setkey  ;; udel w
"edt_reset"	"^[OP^[On"	setkey  ;; reset
"edt_oline"	"^[OP^[Op"	setkey  ;; open line
"edt_chgcase"	"^[OP^[Oq"	setkey  ;; chgcase
"edt_deleol"	"^[OP^[Or"	setkey  ;; deleol
;;
;;  There are two possible definitions for the specins key.  Let's choose
;;  the edt one though I prefer the other
;;
"edt_specins"   "^[OP^[Os"      setkey  ;; specins
;;;;"quoted_insert"	"^[OP^[Os"	setkey  ;; specins
"eob"		"^[OP^[Ot"	setkey  ;; bottom
"bob"		"^[OP^[Ou"	setkey  ;; top
"edt_paste"	"^[OP^[Ov"	setkey  ;; paste
"evaluate_cmd"	"^[OP^[Ow"	setkey  ;; cmd
"format_paragraph" "^[OP^[Ox"	setkey  ;; fill
"edt_replace"	"^[OP^[Oy"	setkey  ;; replace
"exit_mini"	"^[OM"		setkey  ;; enter
;;
;; the enter key requires some care--- it MUST be put in the minibuffer
;;   keymap.  But this is not created until AFTER the init files are loaded
;;   so that it inherits user definitions.  The above line puts it in the
;;   global map so that it behaves properly there.  The same applies to
;;   the 'reset' command.
;;
;; The above comment WAS true in versions prior to 0.81.  Now it is possible
;; to achieve the desired effect in the startup_hook.  I think it is time to 
;; think of a way to chain functions.  That is, I would like to define a 
;; function that startup_hook will call without explicitly modifying startup
;; hook and not destroying other hooks in the process.  Thus, startup_hook
;; should consist of a chain of functions to execute.
;;
"Mini_Map" keymap_p
   { "exit_mini" "^[OM" 	"Mini_Map" definekey  ;; enter
     "edt_reset" "^[OP^[On"	"Mini_Map" definekey  ;; reset
   } if
;;
;;  In EDT, a command may be repeated by GOLD number.  Lets have that too
;;
0 9 1 { string "^[OP" exch strcat "digit_arg" exch setkey } for

;; These are the keys on the vt220 keyboard
"edt_find"      	"^[[1~"		setkey  ;;differs from vt220.sl
"yank"			"^[[2~"		setkey
"kill_region"		"^[[3~"		setkey
"set_mark_cmd"		"^[[4~"		setkey
"page_up"		"^[[5~"		setkey
"page_down"		"^[[6~"		setkey
"evaluate_cmd"		"^[[29~"	setkey
"edt_help"		"^[[28~"	setkey
;;
;;  Finally some definitions for scrolling the screen left/right
;;
"bob"           "^[OP^[[A"   setkey    ; gold ^
"eob"           "^[OP^[[B"   setkey    ; gold v
"scroll_left"   "^[OP^[[C"   setkey    ; gold ->
"scroll_right"  "^[OP^[[D"   setkey    ; gold <-

;; The major complication is the direction.  Here it is:
[edt_dir] 1 =edt_dir

;%%ADVANCE - (4)
;%%Sets the current direction to forward for the CHAR, WORD, LINE, EOL, PAGE,
;%%SECT, SUBS, FIND, and FNDNXT keys.  ADVANCE means that movement will be
;%%toward the end of the buffer; that is, to the right and down.
( 1 =edt_dir "Advance." message
) edt_advance

;%%BACKUP - (5)
;%%Sets the cursor direction to backward for the CHAR, WORD, LINE, EOL, PAGE,
;%%SECT, SUBS, FIND, and FNDNXT keys.  BACKUP means that movement will be
;%%toward the beginning of the buffer; that is, to the left and up.
( -1 =edt_dir "Back." message
) edt_backup

;; other buffers:  not buffers but strings except the char buffer which is int
[edt_wbuf] Null_String =edt_wbuf
[edt_lbuf] Null_String =edt_lbuf
[edt_cbuf] 0 =edt_cbuf

;; character (un)deletion
( eobp { what_char =edt_cbuf del } !if ) edt_cdel
( edt_cbuf { edt_cbuf char insert 1 left pop } if ) edt_ucdel

;; the change to skip whitespace suggested by C. Page (cgp@leicester.ac.uk)
( edt_dir 1 ==
;   {skip_word " \t" skip_chars}{bskip_word} else
    {skip_word}{bskip_word} else
) edt_word

;%%DEL W - (-)
;%%Deletes text from the cursor to the beginning of the next word, storing the
;%%text in the delete word buffer.
(
  push_mark push_mark
  edt_word            ;; use whatever edt_word does as a region
  bufsubstr =edt_wbuf
  del_region
) edt_wdel

;; another one from Clive Page.
( "char code (decimal): " "27" Null_String read_mini eval char insert ) edt_specins
;%%UND W - (GOLD -) 
;%%Inserts the contents of the delete word buffer directly to the left of the
;%%cursor.
( push_spot edt_wbuf insert pop_spot
) edt_uwdel

;; aparantly deleol also saves what it did in buffer...
( push_mark push_mark  eol bufsubstr =edt_lbuf del_region ) edt_deleol
( push_mark push_mark bol  bufsubstr =edt_lbuf del_region ) edt_delbol

;; the line

;%%DEL L - (PF4) 
;%%Deletes text from the cursor position to the end of the current line, including
;%%the line terminator.  If the cursor is positioned at the beginning of a line,
;%%the entire line is deleted.  The deleted text is saved in the delete line
;%%buffer.
(
  push_mark push_mark
  eol
  bufsubstr eobp {"\n" strcat} !if =edt_lbuf
  1 right pop
  del_region
) edt_ldel

;%%UND L - (GOLD PF4)
;%%Inserts the contents of the delete line buffer directly to the left of the
;%%cursor.
( push_spot edt_lbuf insert pop_spot 
) edt_uldel

;%%FIND - (GOLD PF3) 
;%%Searches for an occurrence of a string.  Press the FIND key and then enter the
;%%string using the main keyboard.  End the string by pressing either the ADVANCE
;%%or BACKUP key to set the direction of the search, or the ENTER key to search in
;%%the current direction.
( edt_dir 1 ==  {"search_forward"}{"search_backward"} else call 
) edt_find

;%%FNDNXT - (PF3)
;%%Searches for the next occurrence of the search string previously entered with
;%%the FIND key.  The direction of the search is the current one (ADVANCE or
;%%BACKUP).
( [r]
  LAST_SEARCH strlen
    { LAST_SEARCH
      edt_dir 1 == { 1 right =r fsearch }{ 0 =r bsearch } else
      { 
        r left pop "Not Found." error
      } !if
    }
    { "Find What?" error}
  else
) edt_findnxt

;%%SECT - (8) 
;%%Moves the cursor 16 lines (one section) forward or backward, depending on the
;%%current direction (see ADVANCE and BACKUP).  The cursor is moved to the
;%%beginning of the appropriate line. 
( 16 edt_dir 1 == { down} { up } else pop bol 
) edt_sect

( edt_dir 1 ==
   {eolp {1 down pop} if}
   { 1 up pop}
   else eol
) edt_eol

( edt_dir 1 ==
   { 1 down pop}
   {bolp {1 up pop} if}
   else bol
) edt_line

( 1 edt_dir 1 == {right}{left} else pop ) edt_char
( newline 1 left pop ) edt_oline

;; reset also pops marks.
( edt_advance {markp}{0 pop_mark} while "kbd_quit" call ) edt_reset

;; edt page searches for a form feed.  However, real edt allows user to
;; change this.

;%%PAGE - (7)
;%%Moves the cursor to the top of a page.  A page is defined by a delimiter
;%%string, which can be set by the SET ENTITY command.  The default page
;%%delimiter is the formfeed character (CTRL/L).
( 12 char edt_dir {fsearch}{bsearch} else {1 recenter} if 
) edt_page

;; edt cut
(
  dupmark
  { 
    whatbuf edt_pbuf setbuf erase_buffer setbuf edt_pbuf copy_region del_region
  } if
) edt_cut

( edt_pbuf insbuf ) edt_paste

;; Although not documented in EDT online help, this deletes the region.
;%%APPEND - (9) 
;%%Moves the select range to the end of the PASTE buffer.  The select range is all
;%%the text between the selected position (see SELECT) and the current cursor
;%%position.  If no SELECT has been made and the cursor is positioned on the
;%%current search string, that string is appended.
( whatbuf edt_pbuf setbuf eob setbuf
  dupmark edt_pbuf copy_region del_region
) edt_append

( del_region edt_paste ) edt_replace

;; a real edt_subs function
;; deletes search string, substitutes what is in the pastebuffer and finds
;; the next.
(
  LAST_SEARCH looking_at
    {
      LAST_SEARCH strlen {del} loop
      edt_paste
      edt_findnxt
    } {"Select range not active." error}
  else
) edt_subs

;; a help for the help key
(
   [cbuf f] whatbuf =cbuf
   "JED_LIBRARY" getenv "edt.hlp" dircat find_file
     { onewindow 1 set_readonly }
     { "Help file not found." error}
   else
   
   { cbuf sw2buf } ERROR_BLOCK
   {
    "For help on a function particular key, press that key or return to continue"
    message update
  
    get_key_function =f
    ;;f "edt" 3 strncmp
    LASTKEY strlen 2 >
      {
        f help_for_function
      }{break}
      else
    } forever
    EXECUTE_ERROR_BLOCK
    
) edt_help

;; Chngcase
(
   [n]
   markp
     { push_mark
       LAST_SEARCH strlen =n

       { n { LAST_SEARCH looking_at {n right}{0} else }{0} else }
       { 1 edt_dir 1 == { right } { left } else }
       orelse pop
     } !if
     "X" xform_reg
) edt_chgcase


;; is this a better defn of what edt_replace should be?
;%%REPLACE - (GOLD 9)
;%%Deletes the select range and replaces it with the contents of the PASTE 
;%%buffer.
(
  [n] LAST_SEARCH strlen =n

   n LAST_SEARCH looking_at and {
     n {del} loop
   }{
     markp { "Select range not active." error} !if
     del_region
   } else

   edt_paste
) edt_replace


#comment
 
FILL - (GOLD 8)

Performs a word fill on the select range.  A word fill reformats a block of
text so that as many full words as possible are placed on each line without
exceeding the right margin.  You can set the right margin with the WRAP
variable.  If it is not set, the default is 78.  For purposes of the FILL
command, only spaces are used as word delimiters.
#end
