;; help.sl

;; apropos function
( [n cbuf]

  "apropos:" Null_String Null_String read_mini slapropos =n
  whatbuf =cbuf "*apropos*" pop2buf erase_buffer
  {n}{
    0 4 1 {
       14 * 1 + goto_column
       eolp {n 1 - =n insert trim " " insert} if
       n {break} !if
    } for
    eol newline
  } while
  bob
  0 set_buffer_modified_flag
  cbuf pop2buf
) apropos

;; show key
(
   [f type] 
   "Show Key: " flush
   get_key_function =f        ;; also, type is on stack (if defined)
   f strlen {"Key is undefined." message return} !if
   =type
   
   "Key \"" LASTKEY strcat 
   "\" runs " strcat type {"internal "}{"S-Lang "} else strcat
   "function " strcat f strcat 
   message
) showkey

(
   [n cmd]
   "Where is command:" Null_String Null_String read_mini =cmd
   cmd strlen { return } !if
   cmd which_key =n
   n {"Not on any keys." message return} !if
   message
   n 1 - =n
   n { pop } loop
) where_is

;;
;;  This next functions requires a doc file to be produced.  This is made
;;  by running the executable mkdoc which comes with the distribution.
;;
;;  to produce it. It should be placed in JED_LIBRARY.
;;

( ;; clean up ;%% stuff
  bob
  {1 down}{bol skip_white ";%%" looking_at {del del del} if} while
  0 set_buffer_modified_flag
  1 set_readonly
  bob
) help_cleanup

;%% gets help for a function
(
  [f] =f
  [cbuf] whatbuf =cbuf
  [flen tmp help full_f cbuf]  " *jed-help*" =tmp 
 
  f strlen =flen
  "*function-help*" =help  
  [docfile] "jed_funs.hlp" =docfile
  [p n]
  
  "JED_LIBRARY" getenv docfile dircat =docfile
  docfile file_status 1 != { "Unable to read docfile!" error} if
  
  f slapropos =n
  n 1 > {"Building list..." flush} if
  help pop2buf 0 set_readonly erase_buffer
  
  n {
      =full_f
      f full_f flen strncmp ;;flen and 
      {continue} if
  
      full_f defined? 1 < {continue} if
      "F" full_f strcat docfile get_doc_string 
        {  
	   push_spot
	   insert  ;; help string
	   pop_spot
	   ":" ffind  ;; function:cfun:T:n  where T is type and n is number of args
	     {
	       1 right pop "\tC function: " insert
	       POINT =p ":" ffind {"Corrupt doc file?" error} !if
	       push_spot 1 right pop 
	       what_char
	         { 'V' == : "void "}   ; V
		 { 'S' == : "string "} ; S
		 { pop "int "}            ; I default
	       switch p =POINT insert pop_spot
       
               del del del  ; :T: deleted
	       " (" insert eol trim " args)" insert
	     } if
	} { full_f insert} 
      else
      eob newline 50 {"-" insert} loop newline
    } loop
      
  help_cleanup
  cbuf pop2buf  
) help_for_function

(  
  "Describe Function:" Null_String Null_String read_mini help_for_function
) describe_function


(
  [tmp help f full_f cbuf]  " *jed-help*" =tmp 
  "*function-help*" =help  
  whatbuf =cbuf
  [docfile] "jed_funs.hlp" =docfile
  [p flen n]

  "Describe Variable:" Null_String Null_String read_mini =f
  f strlen =flen ;;flen {return} !if
  
  "JED_LIBRARY" getenv docfile dircat =docfile
  docfile file_status 1 != { "Unable to read docfile!" error} if
  
  f slapropos =n
  n 1 > {"Building list..." flush} if
  help pop2buf 0 set_readonly erase_buffer
  
  n {
      =full_f
      f full_f flen strncmp ;;flen and 
      {continue} if
  
      full_f defined? -1 > {continue} if
      "V" full_f strcat docfile get_doc_string 
        {  
	   push_spot
	   insert  ;; help string
	   pop_spot
	} { full_f insert} 
      else
       
      eol trim "\tvalue: " insert full_f eval string insert
      
      eob newline 50 {"-" insert} loop newline
    } loop
    
    
  newline
  help_cleanup
  cbuf pop2buf
) describe_variable
