;;
;; Info reader for JED
;;

[Info_This_Filename] "" =Info_This_Filename

(
  [file buf] =file Null_String =buf
  [n dir dirfile]
  

  0 =n 
  {
     Info_Directory n ',' extract_element =dir
     dir file dircat expand_filename =dirfile
     dirfile file_status 1 == {break} if
     dirfile strlow =dirfile
     dirfile file_status 1 == {break} if
#VMS
     dirfile "info" strcat =dirfile  ;; VMS adds a '.' upon expansion
#end
#UNIX
     dirfile ".info" strcat =dirfile
#end
#IBMPC
     dirfile ".info" strcat =dirfile
#end
     dirfile file_status 1 == {break} if
     
     dir strlen { "Info file not found: " file strcat error } !if
     n 1 + =n
  } forever
  
  "*Info*" setbuf 
  0 set_readonly
  widen erase_buffer

  dirfile insert_file pop bob
  dirfile =Info_This_Filename
  1 set_readonly
  0 set_buffer_modified_flag
  "Info" 1 setmode 
  "Infomap" use_keymap
) info_find_file

() info_find_node_split_file  ;; extern

[Info_Split_File_Buffer] Null_String =Info_Split_File_Buffer
[Info_Split_Filename] "" =Info_Split_Filename

(
  [the_node node] =the_node
  [len]
  "Node: " the_node strcat =node
  node strlen =len
  widen
  bob  
  {
    "\031" bol_fsearch 
      {
        ;; dont give up, maybe this is a split file
	Info_Split_File_Buffer strlen
          { "Marker not found. " node strcat error } 
	!if
	
	Info_Split_File_Buffer setbuf
	the_node info_find_node_split_file
	return
      } !if
      
    1 down pop bol
    node ffind {continue} !if
    
    ;; is this really it?  ---
    len right pop
    eolp "," looking_at or "\t" looking_at or {break} if
  } forever

  push_mark
  "\031" bol_fsearch {1 left pop} {eob} else
  narrow
  bob
) info_find_node_this_file

( [node] =node
  [tag tagpos pos]
  [buf] " *Info*" =buf
  
  buf bufferp buf setbuf {"*Info*" insbuf} !if
  widen
      
  "Node: " node strcat "\127" strcat =tag
  eob
  
  tag bol_bsearch {"tag not found!." error} !if
  tag strlen right pop 
  push_mark eol bufsubstr integer =tagpos
  
  bob 
  "Indirect:" bol_fsearch pop
  push_mark
  "\031" bol_fsearch {eob} !if 
  narrow
  bob
  {
     1 down pop
     ": " ffind {break} !if
     2 right pop
     push_mark eol bufsubstr integer =pos
     tagpos pos < 
       {
	  Null_String =Info_Split_File_Buffer
          1 up pop bol
	  push_mark
	  ": " ffind pop
	  widen
	  bufsubstr info_find_file
	  node info_find_node_this_file
	  buf =Info_Split_File_Buffer
	  return
       } if
  } forever
  
  widen
  "Split File not found." error
) info_find_node_split_file


(   
  [mark] "\031" =mark

  whatbuf "*Info*" strcmp {return} if
  push_spot push_spot
  mark bol_bsearch pop
  1 down pop push_mark
  pop_spot
  mark bol_fsearch {1 up pop} {eob} else
  narrow
  pop_spot
) info_narrow


; stack for last position 

"Info_Stack_Line" defined?
  {
     [Info_Stack_Depth] 0 =Info_Stack_Depth
     [Info_Stack_File]
     [Info_Stack_Line]
     
     "s" 16 2 2 create_array =Info_Stack_File
     "i" 16 1 create_array =Info_Stack_Line
  } !if


( [line split file] =line =split =file
  [i]
  
  ++Info_Stack_Depth
  Info_Stack_Depth 16 >
    {
      16 =Info_Stack_Depth
      2 16 1 
        {
	  =i
	  i 1 Info_Stack_File aget  ;; file
	  i 2 Info_Stack_File aget  ;; split
	  i Info_Stack_Line aget    ;; line
	  --i
	  i Info_Stack_Line aput
	  i 2 Info_Stack_File aput
	  i 1 Info_Stack_File aput
	}
      for
   } if
   
   file Info_Stack_Depth 1 Info_Stack_File aput 
   split Info_Stack_Depth 2 Info_Stack_File aput 
   line Info_Stack_Depth Info_Stack_Line aput
) info_push_position

(
  [i]
  
  whatbuf "*Info*" strcmp {return} if
  widen
  
  Info_This_Filename 
  Info_Split_File_Buffer strlen
    { Info_Split_Filename }{ Null_String}
  else
  whatline  
  info_push_position
  
  info_narrow
) info_record_position



(
  [node the_node] =node
  [file n] 0 =n
  [len]
  
  info_record_position
  node strlen =len  
  ;; if it looks like (file)node, extract file, node
  
  node "(" is_substr 1 == {node ")" is_substr =n} if
  
  n {
      node =the_node
      the_node n 1 + node strlen substr =node
      the_node n 0 strsub =the_node ;; truncate string
      the_node 2 n substr =file
      file info_find_file
      Info_Split_File_Buffer bufferp
      {
        Info_Split_File_Buffer delbuf
      } if
      Null_String =Info_Split_File_Buffer
    }
   if
  node strlen { "Top" =node } !if
  widen
  push_spot  
  bob
  "\031" bol_fsearch {"Marker not found. " error} !if 
  1 down pop
  
  "Indirect:" looking_at pop_spot
    {Info_This_Filename =Info_Split_Filename node info_find_node_split_file}
    {node info_find_node_this_file}
  else
) info_find_node


;; If buffer has a menu, point is put on line after menu marker if argument
;; is non-zero, otherwise leave point as is.
;; signals error if no menu.
(
  [save] =save
  [menu] "* Menu:" =menu
  push_spot  eob

  menu bol_bsearch
  {
     pop_spot "Node has no menu." error
  } !if
  save {pop_spot return} !if
  eol 1 right pop
  push_mark pop_spot 1 pop_mark
) info_find_menu




;; menu references
(
  [node] Null_String =node
  [colons colon] ":" =colon  "::" =colons
  [menu] "* Menu:" =menu
  
  0 info_find_menu
  
  push_spot bol
  "* " looking_at colon ffind and
    {
      push_mark
      bol 2 right pop
      bufsubstr =node
    } 
  if    
  
  pop_spot
  "Menu item:" node Null_String read_mini =node

  eob
  menu bol_bsearch pop
  
  "* " node strcat
  bol_fsearch { "Menu Item not found." error } !if
  colon ffind { "Corrupt File?" error} !if
  colons looking_at   
    {
       push_mark
       bol 2 right pop
    }
    {
       1 right pop
       skip_white
       push_mark
       '(' char looking_at
         {
	   ')' char ffind pop
	 }
       if
       "\032-\043\045\047-\255" skip_chars  ;; comma, tab, '.', or newline terminates
	 
       " " bskip_chars
    }
  else 
  bufsubstr info_find_node
) info_menu


(
  bob
  "Up: " ffind 
     { "Node has no UP." error } 
  !if
     
  4 right pop push_mark
  "\032-\043\045-\255" skip_chars  ;; comma, tab, or newline terminates
  " " bskip_chars
  bufsubstr
  info_find_node
) info_up

(
  [n] 10 =n
  bob
  "Previous: " ffind
     { "Prev: " ffind {"Node has no PREVIOUS" error } !if
       6 =n
     }
   !if
     
  n right pop push_mark
  "\032-\043\045-\255" skip_chars  ;; comma, tab, or newline terminates
  " " bskip_chars
  bufsubstr
  info_find_node
) info_prev
  
(
  bob
  "Next: " ffind 
     { "Node has no NEXT." error } !if
     
  6 right pop push_mark
  "\032-\043\045-\255" skip_chars  ;; comma, tab, or newline terminates
  " " bskip_chars
  bufsubstr
  info_find_node
) info_next
  
(
   "Summary not available at this time.  Use `h' key for tutorial" error
)info_quick_help
  

"Infomap" keymap_p
  {
     "Infomap"  make_keymap
     "info_quick_help"		"?" "Infomap" definekey
     "info_tutorial"		"h" "Infomap" definekey
     "info_tutorial"		"H" "Infomap" definekey
     "info_menu"		"M" "Infomap" definekey
     "info_menu"		"m" "Infomap" definekey
     "info_next"		"N" "Infomap" definekey
     "info_next"		"n" "Infomap" definekey
     "info_prev"		"P" "Infomap" definekey
     "info_prev"		"p" "Infomap" definekey
     "info_up"			"U" "Infomap" definekey
     "info_up"			"u" "Infomap" definekey
     "page_down"		" " "Infomap" definekey
     "page_up"			"^?" "Infomap" definekey
     "bob"			"B"  "Infomap" definekey
     "bob"			"b"  "Infomap" definekey
     "info_goto_node"		"G" "Infomap" definekey
     "info_goto_node"		"g" "Infomap" definekey
     "info_quit"		"q"  "Infomap" definekey
     "info_quit"		"Q"  "Infomap" definekey
     "info_goto_last_position"	"l"  "Infomap" definekey
     "info_goto_last_position"	"L"  "Infomap" definekey
     "info_search"		"S"  "Infomap" definekey
     "info_search"		"s"  "Infomap" definekey
     "info_follow_reference"	"f"  "Infomap" definekey
     "info_follow_reference"	"F"  "Infomap" definekey
     "info_find_dir"		"D"  "Infomap" definekey
     "info_find_dir"		"d"  "Infomap" definekey
     1 9 1 {
        string "info_menu_number" exch "Infomap" definekey
     } for
  } !if
  
  
(
  [split_file file n]
  [i] Info_Stack_Depth =i
  
  i {return} !if
  
  --Info_Stack_Depth
  
  i 2 Info_Stack_File aget =split_file
  i 1 Info_Stack_File aget =file
  i Info_Stack_Line aget =n
  
  file Info_This_Filename strcmp not
  "*Info*" bufferp and
    {
       widen
       n goto_line
       info_narrow
       return
    } if
    
  split_file strlen
    {
      " *Info*" setbuf
      0 set_readonly
      widen
      erase_buffer
      split_file insert_file pop
      "*Info*" setbuf
    } if
    
  file strlen {return} !if
  file info_find_file
  n goto_line
  info_narrow
) info_goto_last_position
  
( "(DIR)top" info_find_node ) info_find_dir  
(
  Info_Stack_Depth
  {info_goto_last_position} if
  "*Info*" bufferp {info_find_dir} !if
  "*Info*" pop2buf
  onewindow
) info_run_info

(
  info_record_position
  widen
  "*Info*" delbuf
) info_quit

(
  "Node:" Null_String Null_String read_mini info_find_node
) info_goto_node

(
  [this_line this_file str]
  [err_str file] "String not found." =err_str
  [wline]
    
  "Search:" Null_String Null_String read_mini =str
  widen 1 right pop str fsearch {info_narrow return} if
  ;
  ;  Not found.  Look to see if this is split.
  ;
  Info_Split_File_Buffer strlen {info_narrow err_str error} !if
  Info_This_Filename =this_file
  whatline =this_line
  window_line =wline  ;need this so state can be restored after a failure.
  
  
  Info_Split_File_Buffer setbuf widen
  bob
  "Indirect:" bol_fsearch pop
  push_mark
  31 char bol_fsearch {1 up pop}{eob} !if
  narrow
  bob
  this_file extract_filename bol_fsearch pop
  
  {1 down}
    {
      bol
      push_mark
      ":" ffind {0 pop_mark break} !if
      bufsubstr =file
      "Searching " file strcat flush
      file info_find_file
      str fsearch {Info_Split_File_Buffer setbuf continue} !if
      
      info_narrow
      this_file  Info_Split_Filename this_line  info_push_position
      return
    }
  while
  
  widen
  this_file info_find_file
  this_line goto_line eol
  info_narrow
  wline recenter
  err_str error
) info_search

(
  [colon colons] colon ":" =colon  "::" =colons
  [note] "*Note" =note
  [err] "No cross references." =err
  [item node ref]
  push_spot
  
  note fsearch {note bsearch {pop_spot err error} !if } !if
  pop_spot
  
  "Follow *Note" Null_String Null_String read_mini =ref
  push_spot
  bob
  {
     note fsearch {pop_spot "Bad reference." error} !if
     5 right pop
     skip_white
     eolp {1 right pop skip_white} if
     ref looking_at {break} if
  }
  forever
  
  push_mark
  pop_spot
  ;info_record_position
  1 pop_mark
  push_spot
  
  colon fsearch
   { pop_spot "Corrupt File?" error} 
  !if
  colons looking_at   
    {
       push_mark
       pop_spot
       bufsubstr =node
    }
    {
       1 right pop
       skip_white
       eolp {1 right pop skip_white} if
       push_mark
       '(' char looking_at
         {
	   ')' char ffind pop
	 }
       if
       "\032-\043\045\047-\255" skip_chars  ;; comma, tab, '.', or newline terminates
       
       " " bskip_chars
       bufsubstr =node
       pop_spot
    }
  else 
  
  node info_find_node
) info_follow_reference


(
  [node] Null_String =node
  [colons colon] ":" =colon  "::" =colons
  [n]
  
  LAST_CHAR =n
  n '1' < n '9' > or {beep return} if
  '0' -=n
  
  1 info_find_menu

  {n} 
  { 
    "* " bol_fsearch {beep return} !if
    colon ffind {--n} if
  } while
  
  colons looking_at   
    {
       push_mark
       bol 2 right pop
    }
    {
       1 right pop
       skip_white
       push_mark
       '(' char looking_at
         {
	   ')' char ffind pop
	 }
       if
       "\032-\043\045\047-\255" skip_chars  ;; comma, tab, '.', or newline terminates
	 
       " " bskip_chars
    }
  else 
  bufsubstr info_find_node
) info_menu_number


(
 "(info)help"  info_find_node
) info_tutorial
