;; isearch.sl
;; Routines here perform incremental forward/backward searches
;; 
;; ESCAPE key aborts the search
;; ENTER key finds next match
;; DELETE key deletes last character entered and returns to previous point
;;
;;  "isearch_forward"	"^FIf"   setkey  ;(sample bindings)
;;  "isearch_backward"	"^FIb"   setkey

[Isearch_Last_Search] Null_String =Isearch_Last_Search

(
  [dir] =dir
  dir 0 > 
    {"Search:"}
    {"Search Backwards:"}
  else Isearch_Last_Search Null_String read_mini 
  =Isearch_Last_Search
  
  Isearch_Last_Search 
  dir 0 > 
    {fsearch}{bsearch} else
  {"Not Found." error} !if
) isearch_simple_search

(
   [str] =str
   [n] str strlen =n
   n {
       str 1 n 1 - substr =str
     } if
   str
) isearch_del

(
  [dir] =dir
  [prompt] "Isearch " dir 1 == {"forward: "}{"Backward: "} else strcat =prompt 
  [str] Null_String =str
  [c m int first] push_mark 1 =m   1 =first
  
  { m { 0 pop_mark pop } loop } ERROR_BLOCK  ;; make sure we pop marks
  
  {
     prompt str strcat message
     push_spot
     dir 0 > str looking_at and
     {
       str strlen right pop
     } if
     update
     pop_spot
       
     getkey =c
     c { 27 == first and : dir isearch_simple_search break}
       { 27 == : break}
       { 13 == : dir 1 == { 1 right pop } if }
       { 127 == : str isearch_del =str 
                  m {--m 1 pop_mark pop } if
		  m {1 =m push_mark} !if
		  continue
       }
       { char str exch strcat =str
         str looking_at {++m push_mark} !if
         ;;m 1 + =m push_mark
	 ;;str looking_at 1 dir == and {1 right pop} if
       }
     switch
     0 =first 
     
     str dir 1 == {fsearch}{bsearch} else
     {
       str " not found." strcat flush beep
       1 input_pending pop
       c 13 == {1 left pop} 
               {str isearch_del =str 0 pop_mark pop --m}
	     else
     } !if
     
  } forever
  
  EXECUTE_ERROR_BLOCK
  str strlen {str =Isearch_Last_Search} if
  dir 1 == {str strlen right pop} if
  "Done." message
) isearch_dir

( 1 isearch_dir )  isearch_forward 
( -1 isearch_dir ) isearch_backward

  
