#REM            Site specific initialiation file.

This file must be present in the JED_LIBRARY.  JED loads it first--- even
before reading command line arguments.  The command line arguments are then
passed to a hook declared in this file for further processing.

In addition to some hooks, this file declares some autoloads for various
functions and defines utility functions.  Any user specific stuff should be
placed in the jed.rc (.jedrc) user startup file.  Only put here what you
believe EVERY user on your system should get!
#end rem

;
;     Global Variables
;

;%% A Comma separated list of info directories to search.
[Info_Directory]  
#UNIX
; If you already have info files use the following one
;;"/usr/local/emacs/lib/info,/usr/local/info" =Info_Directory
; otherwise:
"JED_LIBRARY" getenv =Info_Directory
#end
#VMS
"JED_LIBRARY:" =Info_Directory
#end
#IBMPC
"JED_LIBRARY" getenv =Info_Directory
#end

[Null_String]       "" =Null_String

;;
;; Some key definitions
;;
"skip_word"	"^[^[[C"	setkey  ;escape right arrow.
"bskip_word"	"^[^[[D"	setkey  ;escape left arrow

"undo"			"^Xu"	setkey  ;; Also ^_ but vtxxx have problems with it
"transpose_lines"	"^X^T"	setkey 
"help"			"^H^H"  setkey
"apropos"		"^HA"	setkey
"info_run_info" 	"^HI"	setkey
"menu_main_cmds"	"^H?"	setkey
"describe_function"	"^HF"	setkey
"describe_variable"	"^HV"	setkey
"where_is"		"^HW"	setkey
"showkey"		"^HC"	setkey
"do_shell_cmd"		"^[!"	setkey
"find_tag"		"^[."	setkey
"save_buffers"		"^Xs"	setkey
"whatpos"		"^X?"	setkey
"list_buffers"		"^X^B"	setkey
#IBMPC
"coreleft"		"^Hm"	setkey
#end
#UNIX
  "unix_man" 	"^Hm"	setkey
  "ispell"	"^[$"	setkey
  "mail"	"^Xm"	setkey
#end

;;
;;  Autoloads
;;

#IBMPC
"lpr"			"lpr.sl"	autoload
#end
#VMS
"dcl"			"dcl.sl"	autoload
#end
"menu_main_cmds"	"menu.sl"	autoload
"trim_buffer"		"util.sl"	autoload  ;; trims excess lines and space
"occur"			"util.sl"	autoload  ;; find all command
"info_run_info"		"info.sl"	autoload
"list_buffers"		"buf.sl"	autoload
"append_region"		"buf.sl"	autoload
"write_region"		"buf.sl"	autoload
"recover_file"		"buf.sl"	autoload
"most_mode"		"most.sl"	autoload
"run_most"		"most.sl"	autoload
"compile"		"compile.sl"	autoload
"sort"			"sort.sl"	autoload
"untab"			"untab.sl"	autoload
"fortran"		"fortran.sl"	autoload
"save_buffers"		"buf.sl"	autoload
"rot13"			"rot13.sl"	autoload
"isearch_forward"	"isearch.sl"	autoload
"isearch_backward"	"isearch.sl"	autoload
"shell"			"shell.sl"	autoload
"do_shell_cmd"		"shell.sl"	autoload
"find_tag"		"ctags.sl"	autoload
"apropos"		"help.sl"	autoload
"describe_function"	"help.sl"	autoload
"describe_variable"	"help.sl"	autoload
"help_for_function"	"help.sl"	autoload
"where_is"		"help.sl"	autoload
"showkey"		"help.sl"	autoload
;;
;; By default, tabs are every TAB columns (default 8).  Calling this function
;; will allow the user to set the tabs arbitrarily and bind the TAB key
;; appropriately.
"edit_tab_stops"	"tabs.sl"	autoload

#UNIX
  "unix_man"		"man.sl"	autoload
  "mail"		"mail.sl"	autoload
  "rmail"		"rmail.sl"	autoload
  "ispell"		"ispell.sl"	autoload
#end UNIX

;; A useful hooks function---
;; There is a builtin one in slang as well that is called from C code
( [hook_fun] =hook_fun  hook_fun defined? { hook_fun eval } if ) runhooks

;; useful functions for use in user hooks--- operate on current keymap
( [key f map] =key =f what_keymap =map f key map definekey) local_setkey
( [key f map] =key what_keymap =map key map undefinekey) local_unsetkey

;%%   insert a newline in buffer
("\n" insert
) newline  

;%% returns type of file.  e.g., /usr/a.b/file.c --> c
(

   [file n] extract_filename =file
   
   file "." is_substr =n
   n {Null_String return} !if
   file n 1 + file strlen substr
) file_type


;%% A function to contat a directory with a filename.  Basically checks
;%% for the final slash on the dir and adds on if necessary
(
   [dir file] =file =dir
   [n] dir strlen =n
#IBMPC
   [slash] "\\" =slash
   n {
       dir n 1 substr slash strcmp {dir slash strcat =dir} if
     } if
   dir file strcat
#end
#UNIX
   [slash] "/" =slash
   n {
       dir n 1 substr slash strcmp {dir slash strcat =dir} if
     } if
   dir file strcat
#end
#VMS
   dir file strcat return
#end
) dircat

;;; scroll other window macros-- bind them yourself
(nwindows 1 - otherwindow "page_up" call {otherwindow} loop ) next_wind_up
(nwindows 1 - otherwindow "page_down" call { otherwindow } loop ) next_wind_dn

( "C" 2 setmode ) c_mode
( "Text" 1 setmode ) text_mode
( Null_String 0 setmode ) no_mode

; Function prototypes
; These 'functions' are only here to initialize function pointers.

( pop 0 ) _function_pop_0

;%% called from mode_hook.  Returns 0 if it is desired that control return
;%% to mode_hook or 1 if mode hook should exit after calling mode_hook_ptr
[mode_hook_pointer] &_function_pop_0 =mode_hook_pointer


;%% This is a hook called by find_file routines to set the mode
;%% for the buffer. This function takes one parameter, the filename extension
;%% and returns nothing.
(
  [ext] =ext
  ext mode_hook_pointer {return} if
  ext
  {"c"   strcmp not : c_mode}
  {"h"   strcmp not : c_mode}
  {"tex" strcmp not : text_mode}
  {"txt" strcmp not : text_mode}
  {"doc" strcmp not : text_mode}
  {"f"   strcmp not : fortran }
  {"for" strcmp not : fortran }
  {"dat" strcmp not : no_mode }
  {"sl"  strcmp not : no_mode } 
  {"rc"  strcmp not : no_mode } 
#UNIX
  {"jedrc"  strcmp not : no_mode } 
  {"cshrc"  strcmp not : no_mode } 
  {"tcshrc"  strcmp not : no_mode }
  {"login"  strcmp not : no_mode } 
  {"profile"  strcmp not : no_mode }
#end
#VMS
  {"com" strcmp not : dcl}
#end
  {"ci"   strcmp not : c_mode}
  {pop text_mode} ;;  default
  switch
) mode_hook 

;%% sets buf modified flag. If argument is 1, mark
;%% buffer as modified.  If argument is 0, mark buffer as unchanged.
(
  [mod] =mod getbuf_info mod { 1 |}{1 ~ &} else setbuf_info
) set_buffer_modified_flag

;%% set undo mode for buffer.  If argument is 1, undo is on.  0 turns it off
(
  [mod] =mod getbuf_info mod { 32 |}{32 ~ &} else setbuf_info
) set_buffer_undo

( getbuf_info 8 xor setbuf_info ) toggle_readonly
( getbuf_info 16 xor setbuf_info ) toggle_overwrite
( getbuf_info 32 xor setbuf_info ) toggle_undo

( POINT bol push_mark eol bufsubstr newline insert =POINT) double_line

( [line] bol push_mark push_mark eol bufsubstr =line
  1 right pop del_region
  1 up pop bol line insert newline 1 down bol ) transpose_lines

;%% Takes 1 parameter: 0 turn off readonly
;%%                    1 turn on readonly
( [n] =n getbuf_info n { 8 |}{8 ~ &} else setbuf_info 
) set_readonly

;%% Takes 1 parameter: 0 turn off overwrite
;%%                    1 turn on overwrite
( [n] =n getbuf_info n { 16 |}{16 ~ &} else setbuf_info 
) set_overwrite

;%% called from main in JED executable.
;%% The top element of stack is number of command line parameters--- n. 
;%% Then the next element is argv[0], followed by the n command
;%% line parameters.  n is NOT argc, it is argc - 1.
( [n i file]
  
  [mark] "@#$thisisamark@#$" =mark
  [jedrc home] "jed.rc" =jedrc
#UNIX
  ".jedrc" =jedrc
#end
  "JED_HOME" getenv =home
#VMS
;; allows JED_HOME: to be search list---
;; thanks to SYSTEM@VACMZB.chemie.Uni-Mainz.DE for suggestion
  home strlen {"JED_HOME:" =home} if   
#end
  home strlen
   {
     "HOME" getenv =home
#VMS
     "SYS$LOGIN:" =home
#end
   } !if
   home jedrc dircat =jedrc
   
   MAIN_ARGC =n
   
   n 1 - =n  ;; argv[0], here it is not used.
;
;  If batch then first argument is not used so start at second
;  Also, n is the number of effective command line parameters so reduce it.
;
   BATCH {n 1 - =n 2} 
         {1} 
       else =i
;
; if first argument is -n then do NOT load init file
;
  {n not}{i command_line_arg "-n" strcmp} orelse
   {
     mark
     jedrc file_status 1 == {jedrc evalfile}{"jed.rc" evalfile} else
     {string mark strcmp}{} while  ;; user may have left stuff on stack
   }{n { ++i } if}
   else
   
   MAIN_ARGC i - =n
   n {return} !if
;
; Is JED to emulate most?
;
   i command_line_arg "-most" strcmp
     {
       i 1 + run_most
       return
     } !if
   
   { n 0 > }
   {
     i command_line_arg =file
     --n
     ++i
     
         file {"-f" strcmp not n and : i command_line_arg eval }
	      {"-g" strcmp not n and : i command_line_arg integer goto_line }
	      {"-s" strcmp not n and : i command_line_arg fsearch pop }
	      {"-l" strcmp not n and : i command_line_arg evalfile pop }
	      {"-2" strcmp not : splitwindow ++n --i}
	      {find_file pop ++n --i}
	     switch
	 --n
	 ++i
    } while
) command_line_hook 


;%% string to display at bottom of screen upon JED startup and when
;%% user executes the help function.
[help_for_help_string]

"^H -> Help:^H  Menu:?  Info:I  Apropos:A  Key:C  Function:F  Variable:V"
=help_for_help_string

; Load minibuffer routines now before any files are loaded.
; This will reduce fragmentation on PC.
"mini.sl" evalfile pop

;; startup hook
;%% Function that gets executed right before JED enters its main editing
;%% loop.  This is for last minute modifications of data structures that
;%% did not exist when startup files were loaded (e.g., minibuffer keymap)
(
   [n hlp ok] 0 =ok
#IBMPC
     "next_mini_command"	"^@P"	"Mini_Map" definekey
     "prev_mini_command"	"^@H"	"Mini_Map" definekey
#end
#UNIX
     "next_mini_command"	"^[[B"	"Mini_Map" definekey
     "prev_mini_command"	"^[[A"	"Mini_Map" definekey
#endif
#VMS
     "next_mini_command"	"^[[B"	"Mini_Map" definekey
     "prev_mini_command"	"^[[A"	"Mini_Map" definekey
#endif
   "mini_exit_minibuffer" "^M" "Mini_Map" definekey
   "exit_mini" "^[^M" "Mini_Map" definekey
  

;; if you want to startup jed with a filename use these 3 lines:
;  whatbuf "*scratch*" strcmp {return} if
;  {"Enter Filename:" read_file_from_mini dup strlen {break} if} forever
;  find_file pop

   "help" which_key =n
   n {return} !if
   =hlp hlp
   n {
      "^H^H" strcmp {
       help_for_help_string message
       1 =ok
       } !if
     } loop
   ok {"For help, enter " hlp strcat message} !if
) jed_startup_hook

;%% display row and column information in minibuffer
( 
   count_chars ", Line " strcat
   whatline string strcat " of " strcat
   push_spot eob whatline string pop_spot strcat
   " lines, Column " what_column
   string strcat strcat 
   message 
) whatpos
;;
;; help function
;;

;%% name of the file to load when the help function is called.
[Help_File] "jed.hlp" =Help_File   ;; other modes will override this.

;%% Pop up a window containing a help file.  The help file that is read
;%% in is given by the variable Help_File.
(
   [hlp] "*help*"  =hlp
   [lib] "JED_LIBRARY" getenv =lib
   [file buf]
   [rows]

   Help_File strlen {"No help file available." error} !if
   whatbuf =buf
   onewindow
   window_size pop =rows
   Help_File =file  ;;defined? {"Help_File" eval}{"jed.hlp"} else =file
   hlp setbuf
   0 set_readonly
   erase_buffer
   lib file dircat insert_file 0 < {"Help file not found!" error} if
   hlp pop2buf bob
   0 set_buffer_modified_flag
   1 set_readonly
   buf pop2buf
   rows 2 / 7 - {enlargewin} loop
   help_for_help_string message
) help

#VMS
;; This resume hook is need for VMS when returning from spawn.
;; In fact, it is NEEDED for certain JED functions on VMS so declare it.
( [file]
  "JED_FILE_NAME" getenv =file
  file strlen {return} !if
  file find_file {"File not found!" error} !if
) resume_hook
#end VMS


;;file hooks
;%% returns backup filename.  Arguments to function are dir and file.
(
#VMS
  return
#end
#UNIX
  strcat "~" strcat
#end
#IBMPC
  strcat "~" strcat
#end
) make_backup_filename

;%% returns backup filename.  Arguments to function are dir and file.
(
#VMS
  "_$" exch strcat ";1" strcat  ;; makes file -> _$file;1
  strcat
#end
#UNIX
  [p] "#" =p
  p exch strcat p strcat strcat
#end
#IBMPC
  "#" exch strcat strcat
#end
) make_autosave_filename

;%% breaks a filespec into dir filename
(
  [fn] =fn
  [f dir]
  [n]
  
  fn extract_filename =f
  fn strlen f strlen - 1 + =n
  fn n 0 strsub =dir
  dir f
) parse_filename

;%% called before a file is read in to a buffer.  FILENAME is on the stack.
(
   [file dir a f] =file
   file parse_filename =f =dir
   
   dir f make_autosave_filename =a
   a f file_time_compare 0 >
     {
       "Autosave file is newer. Use ESC-X recover_file."
       flush 1 input_pending pop
     } 
    if
) find_file_hook
